unit PrevAppRepeat;

interface

uses
  WinTypes, WinProcs, SysUtils, registry, Forms, Inifiles,Dialogs, Messages;

type
  PFindWindowStruct = ^TFindWindowStruct;
  TFindWindowStruct = record
    Caption : string;
    ClassName : string;
    WindowHandle : THandle;
  end;


 PHWND = ^HWND;

 function FindAWindow(Caption : string; ClassName : string) : THandle;
 function EnumWindowsProc(hWindow : hWnd;lParam  : LongInt) : Bool
{$IFDEF Win32} stdcall; {$ELSE} ; export; {$ENDIF}
 procedure RegisterMyExtName(ExeName,ExtName,Description:string);
 procedure AllotCPUTime;
 function GetCurrentUserName: string;
 function EnumFunc(Wnd:HWND; TargetWindow:PHWND): bool; export;
 procedure GotoPreviousInstance;
 function _isNT : Boolean;
 procedure RegisterWin32;
 procedure UnRegisterWin32;
 procedure RegisterWin16;
 procedure DosMode;
 function IsStrANumber(NumStr : string) : bool;
 function TurnScreenSaverOn : bool;

implementation

function EnumWindowsProc(hWindow : hWnd;lParam  : LongInt) : Bool
{$IFDEF Win32} stdcall; {$ELSE} ; export; {$ENDIF}
var
  lpBuffer : PChar;
  WindowCaptionFound : bool;
  ClassNameFound : bool;

begin
  GetMem(lpBuffer, 255);
  Result := True;
  WindowCaptionFound := False;
  ClassNameFound := False;

  try
    if GetWindowText(hWindow, lpBuffer, 255) > 0 then
      if Pos(PFindWindowStruct(lParam).Caption, StrPas(lpBuffer)) > 0
       then WindowCaptionFound := true;

    if PFindWindowStruct(lParam).ClassName = '' then
      ClassNameFound := True else
        if GetClassName(hWindow, lpBuffer, 255) > 0 then
          if Pos(PFindWindowStruct(lParam).ClassName, StrPas(lpBuffer))
           > 0 then ClassNameFound := True;

    if (WindowCaptionFound and ClassNameFound) then begin
      PFindWindowStruct(lParam).WindowHandle := hWindow;
      Result := False;
    end;

  finally
    FreeMem(lpBuffer, sizeof(lpBuffer^));
  end;
end;

function FindAWindow(Caption : string; ClassName : string) : THandle;
var
  WindowInfo : TFindWindowStruct;
begin
  with WindowInfo do begin
    Caption := Caption;
    ClassName := ClassName;
    WindowHandle := 0;
    EnumWindows(@EnumWindowsProc, LongInt(@WindowInfo));
    FindAWindow := WindowHandle;
  end;
end;


procedure RegisterMyExtName(ExeName,ExtName,Description:string);
var
  R : TRegIniFile;
  DotExt:string;
begin
  DotExt:='.'+ExtName;

  R := TRegIniFile.Create('');
  with R do begin
    RootKey := HKEY_CLASSES_ROOT;
    WriteString(DotExt,'',ExtName);
    WriteString(ExtName,'',Description);
    WriteString(ExtName+'\DefaultIcon','',ExeName+',0');
    WriteString(ExtName+'\Shell','','This_Is_Our_Default_Action');
    WriteString(ExtName+'\Shell\First_Action','','This is our first action');
    WriteString(ExtName+'\Shell\First_Action\command','',
        ExtName+'/LotsOfParamaters %1');
    WriteString(ExtName+'\Shell\This_Is_Our_Default_Action','',
       'This is our default action');
    WriteString(ExtName+'\Shell\This_Is_Our_Default_Action\command',
       '',ExtName+' %1');
    WriteString(ExtName+'\Shell\Second_Action','','This is our second action');
    WriteString(ExtName+'\Shell\Second_Action\command',
       '',ExtName+'/TonsOfParameters %1');
    Free;
  end;
end;



procedure AllotCPUTime;
var
  ProcessID : DWORD;
  ProcessHandle : THandle;
  ThreadHandle : THandle;
begin
  ProcessID := GetCurrentProcessID;
  ProcessHandle := OpenProcess(PROCESS_SET_INFORMATION, false, ProcessID);
  SetPriorityClass(ProcessHandle, REALTIME_PRIORITY_CLASS);
  ThreadHandle := GetCurrentThread;
  SetThreadPriority(ThreadHandle, THREAD_PRIORITY_TIME_CRITICAL);
end;



function GetCurrentUserName: string;
var
  Len: Cardinal; { This will have to be Integer, not cardinal, in Delphi 3. }
begin
  Len := 255;  { arbitrary length to allocate for username string, plus one for null terminator }
  SetLength(Result, Len - 1); { set the length }
  if GetUserName(PChar(Result), Len) then  { get the username }
    SetLength(Result, Len - 1) { set the exact length if it succeeded }
  else
  begin
    RaiseLastWin32Error; { raise exception if it failed }
  end;
end;


function EnumFunc(Wnd:HWND; TargetWindow:PHWND): bool;
var
  ClassName : array[0..30] of char;
begin
  Result := true;
  if GetWindowLong(Wnd,GWL_HINSTANCE) = hPrevInst then
  begin
    GetClassName(Wnd,ClassName,30);
    if StrIComp(ClassName,'TApplication') = 0 then

    begin
      TargetWindow^ := Wnd;
      Result := false;
    end;
  end;
end;

procedure GotoPreviousInstance;
var
  PrevInstWnd : HWND;
begin
  PrevInstWnd := 0;
  EnumWindows(@EnumFunc,longint(@PrevInstWnd));
  if PrevInstWnd <> 0 then
    if IsIconic(PrevInstWnd) then
      ShowWindow(PrevInstWnd, SW_RESTORE)
    else
      BringWindowToTop(PrevInstWnd);
end;

function _isNT : Boolean;
var
  osver:TOSVERSIONINFO;
begin
  osver.dwOSVersionInfoSize:=sizeof(osver);
  GetVersionEx(osver);
  if osver.dwPlatformId=VER_PLATFORM_WIN32_NT then
    result:=true
  else
    result:=false;
end;    


{For Win32}
procedure RegisterWin32;
var
  reg: TRegistry;
begin
  reg := TRegistry.Create;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  reg.LazyWrite := false;
  reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', true);
  reg.WriteString(ExtractFileName(Application.ExeName) , Application.ExeName);
  reg.CloseKey;
  reg.free;
end;

procedure UnRegisterWin32;
var
  reg: TRegistry;
  keyStr:String;
begin
  reg := TRegistry.Create;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  reg.LazyWrite := false;
  keyStr:='Software\Microsoft\Windows\CurrentVersion\Run\'+ExtractFileName(Application.ExeName);
  reg.DeleteKey(keyStr);
  reg.free;
end;

{Auto Start by For Win16}
procedure RegisterWin16;
var
  WinIni : TIniFile;
  WinIniFileName : array[0..MAX_PATH] of char;
  s : string;
begin
  GetWindowsDirectory(WinIniFileName, sizeof(WinIniFileName));
  StrCat(WinIniFileName, '\win.ini');
  WinIni := TIniFile.Create(WinIniFileName);
  s := WinIni.ReadString('windows','run', '');
  if s = '' then
    s := Application.ExeName else
    s := s + ';' + Application.ExeName;
  WinIni.WriteString('windows', 'run', s);
  WinIni.Free;
end;

procedure DosMode;
begin
  WinExec('COMMAND.COM', SW_SHOWNORMAL);

  {
  //To execute a standard program, simply use:
  WinExec('C:\WINDOWS\NOTEPAD.EXE', SW_SHOWNORMAL);

  //To add a command line, use:
  WinExec('C:\WINDOWS\NOTEPAD.EXE C:\WINDOWS\WIN.INI', SW_SHOWNORMAL);

  //To pop up a DOS box, use:
  WinExec('COMMAND.COM', SW_SHOWNORMAL);

  //To execute a DOS command, use:
  WinExec('COMMAND.COM /C DIR *.*', SW_SHOWNORMAL);
  }
end;

function IsStrANumber(NumStr : string) : bool;
begin
  result := true;
  try
    StrToInt(NumStr);
  except
    result := false;
  end;
end;

function TurnScreenSaverOn : bool;
var
  b : bool;
begin
  result := false;
  if SystemParametersInfo(SPI_GETSCREENSAVEACTIVE, 0, @b, 0) <> true then exit;
  if not b then exit;
  PostMessage(GetDesktopWindow, WM_SYSCOMMAND, SC_SCREENSAVE, 0);
  result := true;
end;



end.


